# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Copyright 2009 Chris Oliver

import os.path
import logging
import re
import sys


definitions = []


def __initialize(dir="definitions"):
    """Initializes OS definitions"""
    global definitions
    path = os.path.join(os.path.abspath(os.path.dirname(__file__)), dir)
    sys.path.append(path) # Append the path so that we can import from it
    files = os.listdir(path)
    #test = re.compile('', re.IGNORECASE)
    #files = filter(test.search, files)
    filenameToModuleName = lambda f: os.path.splitext(f)[0]
    moduleNames = map(filenameToModuleName, files)
    definitions = map(__import__, moduleNames)
    logging.info("Loaded %i definition(s)" % len(definitions))
    logging.debug(definitions)


# shouldn't this be get_project?
def GetProject(name, db_file=None):
    """Returns a definition instance for a project called 'name'
    Raises exception on failure
    """
    
    # No database was supplied, use the default libkeryx database
    if not db_file:
        db_file = os.path.join(os.path.dirname(__file__), 'keryx.db')
    
    try:
        return getattr(definitions[0], definitions[0].__name__)(name, db_file)
    except Exception, e:
        logging.error(e)
    
    
# Entry point
__initialize()
