# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Library General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

# Copyright 2009 Chris Oliver

import definition
from sqlalchemy import create_engine, ForeignKey, Column, Integer, String

# These are the mapper classes to help access the database easier.
# Only define the tables that are generic to all definitions not 
# the definition-specific ones.
class Project(definition.Base):
    """Table for storing projects"""
    __tablename__ = "projects"
    
    id = Column(Integer, primary_key=True)
    name = Column(String, unique=True)
    architecture = Column(String)
    hostname = Column(String)
    definition = Column(String)
    version = Column(String)
  
    def __init__(self, name, architecture, hostname, definition, version):
        self.name = name
        self.architecture = architecture
        self.hostname = hostname
        self.definition = definition
        self.version = version
    
    def __repr__(self):
        return "<Project('%s','%s','%s','%s','%s')>" % (self.name, 
            self.architecture, self.hostname, self.definition, self.version)

